---
title: ':focus-within'
slug: 'Web/CSS/:focus-within'
tags:
  - ':focus'
  - ':focus-within'
  - CSS
  - Layout
  - Pseudo-class
  - Reference
  - Selector
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>:focus-within</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents an element that has received focus or <em>contains</em> an element that has received focus. In other words, it represents an element that is itself matched by the {{CSSxRef(":focus")}} pseudo-class or has a descendant that is matched by <code>:focus</code>. (This includes descendants in <a href="/en-US/docs/Web/Web_Components/Shadow_DOM">shadow trees</a>.)</p>

<pre class="brush: css no-line-numbers notranslate">/* Selects a &lt;div&gt; when one of its descendants is focused */
div:focus-within {
  background: cyan;
}</pre>

<p>This selector is useful, to take a common example, for highlighting an entire {{HTMLElement("form")}} container when the user focuses on one of its {{HTMLElement("input")}} fields.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<p>In this example, the form will receive special coloring styles when either text input receives focus.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;Try typing into this form.&lt;/p&gt;

&lt;form&gt;
  &lt;label for="given_name"&gt;Given Name:&lt;/label&gt;
  &lt;input id="given_name" type="text"&gt;
  &lt;br&gt;
  &lt;label for="family_name"&gt;Family Name:&lt;/label&gt;
  &lt;input id="family_name" type="text"&gt;
&lt;/form&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css highlight[7] notranslate">form {
  border: 1px solid;
  color: gray;
  padding: 4px;
}

form:focus-within {
  background: #ff8;
  color: black;
}

input {
  margin: 4px;
}
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Examples", 500, 150)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSS4 Selectors", "#the-focus-within-pseudo", ":focus-within")}}</td>
			<td>{{Spec2("CSS4 Selectors")}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.focus-within")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{CSSxRef(":focus")}}</li>
	<li>{{CSSxRef(":focus-visible")}} {{Experimental_Inline}}</li>
	<li><a href="https://dev.to/vtrpldn/grab-your-user-s-attention-with-the-focus-within-css-selector-4d4">Grab your user's attention with the focus-within selector</a></li>
</ul>
